/**************************************************
**** SUDOSTICK PROGRAM                           **
**** Cornell University                          **
**** Copyright: Jeremy Blum (www.jeremyblum.com) **
***************************************************/

//LED Pins
int LED1_red = 3;
int LED1_green = 5;
int LED1_blue = 6;
int LED2_red = 9;
int LED2_green = 10;
int LED2_blue = 11;

//Serial Buffers
int red[5];
int green[5];
int blue[5];

//Sensor Values
int red_val = 0;
int green_val = 0;
int blue_val = 0;


void setup(){
  
  pinMode(LED1_red, OUTPUT);
  pinMode(LED1_green, OUTPUT);
  pinMode(LED1_blue, OUTPUT);
  pinMode(LED2_red, OUTPUT);
  pinMode(LED2_green, OUTPUT);
  pinMode(LED2_blue, OUTPUT);
  
  
  Serial.begin(9600);
  Serial.flush();
  
}

 
 
void loop()
{
  
  //Get commands
  //Wait for max char num (
  if(Serial.available()>12)
  {
    char check = Serial.peek();
    if(check == '.')
    {
     Serial.read(); //remove '.'
      int red_buff_len = 0;
      while(Serial.peek() != '_')
      {
        red[red_buff_len] = Serial.read();
        red_buff_len++;
      }
      Serial.read();
      
      int green_buff_len = 0;
      while(Serial.peek() != '_')
      {
        green[green_buff_len] = Serial.read();
        green_buff_len++;
      }
      Serial.read();
      
      int blue_buff_len = 0;
      while(Serial.peek() != '.')
      {
        blue[blue_buff_len] = Serial.read();
        blue_buff_len++;
      }
      
      //Parse buffers
      if (red_buff_len == 3) 
        red_val = 100*(red[0] - '0') + 10*(red[1]-'0') + (red[2]-'0');
      else if (red_buff_len == 2)
        red_val = 10*(red[0]-'0') + (red[1]-'0');
      else
        red_val = red[0]-'0';
      if (green_buff_len == 3) 
        green_val = 100*(green[0] - '0') + 10*(green[1]-'0') + (green[2]-'0');
      else if (green_buff_len == 2)
        green_val = 10*(green[0]-'0') + (green[1]-'0');
      else
        green_val = green[0]-'0';
      if (blue_buff_len == 3) 
        blue_val = 100*(blue[0] - '0') + 10*(blue[1]-'0') + (blue[2]-'0');
      else if (blue_buff_len == 2)
        blue_val = 10*(blue[0]-'0') + (blue[1]-'0');
      else
        blue_val = blue[0]-'0';
             

        analogWrite(LED1_red, red_val);
        analogWrite(LED2_red, red_val);

        analogWrite(LED1_green, green_val);
        analogWrite(LED2_green, green_val);

        analogWrite(LED1_blue, blue_val);
        analogWrite(LED2_blue, blue_val);
    }
    Serial.flush(); 
  }
  
}
    

